PMInstall - nocheck

From Scribby Camel, 7 Years ago, written in Bash, viewed 657 times.
URL https://code.nat.moe/view/b51d8676 Embed
Download Paste or View Raw
  1. #!/bin/bash
  2.  
  3. CHANNEL="stable"
  4. NAME="PocketMine-MP"
  5.  
  6. LINUX_32_BUILD="PHP_5.6.4_x86_Linux"
  7. LINUX_64_BUILD="PHP_5.6.4_x86-64_Linux"
  8. CENTOS_32_BUILD="PHP_5.6.2_x86_CentOS"
  9. CENTOS_64_BUILD="PHP_5.6.2_x86-64_CentOS"
  10. MAC_32_BUILD="PHP_5.6.4_x86_MacOS"
  11. MAC_64_BUILD="PHP_5.6.4_x86-64_MacOS"
  12. RPI_BUILD="PHP_5.6.4_ARM_Raspbian_hard"
  13. # Temporal build
  14. ODROID_BUILD="PHP_5.6.4_ARM_Raspbian_hard"
  15. AND_BUILD="PHP_5.6.4_ARMv7_Android"
  16. IOS_BUILD="PHP_5.5.13_ARMv6_iOS"
  17. update=off
  18. forcecompile=off
  19. alldone=no
  20. checkRoot=on
  21. XDEBUG="off"
  22.  
  23. INSTALL_DIRECTORY="./"
  24.  
  25. IGNORE_CERT="yes"
  26.  
  27. while getopts "rxucid:v:" opt; do
  28.   case $opt in
  29.     r)
  30.           checkRoot=off
  31.       ;;
  32.     x)
  33.           XDEBUG="on"
  34.           echo "[+] Enabling xdebug"
  35.       ;;
  36.     u)
  37.           update=on
  38.       ;;
  39.     c)
  40.           forcecompile=on
  41.       ;;
  42.         d)
  43.           INSTALL_DIRECTORY="$OPTARG"
  44.       ;;
  45.         i)
  46.           IGNORE_CERT="no"
  47.       ;;
  48.         v)
  49.           CHANNEL="$OPTARG"
  50.       ;;
  51.     \?)
  52.       echo "Invalid option: -$OPTARG" >&2
  53.           exit 1
  54.       ;;
  55.   esac
  56. done
  57.  
  58.  
  59. #Needed to use aliases
  60. shopt -s expand_aliases
  61. type wget > /dev/null 2>&1
  62. if [ $? -eq 0 ]; then
  63.         if [ "$IGNORE_CERT" == "yes" ]; then
  64.                 alias download_file="wget --no-check-certificate -q -O -"
  65.         else
  66.                 alias download_file="wget -q -O -"
  67.         fi
  68. else
  69.         type curl >> /dev/null 2>&1
  70.         if [ $? -eq 0 ]; then
  71.                 if [ "$IGNORE_CERT" == "yes" ]; then
  72.                         alias download_file="curl --insecure --silent --location"
  73.                 else
  74.                         alias download_file="curl --silent --location"
  75.                 fi
  76.         else
  77.                 echo "error, curl or wget not found"
  78.         fi
  79. fi
  80.  
  81. if [ "$checkRoot" == "on" ]; then
  82.         if [ "$(id -u)" == "0" ]; then
  83.            echo "This script is running as root, this is discouraged."
  84.            echo "It is recommended to run it as a normal user as it doesn't need further permissions."
  85.            echo "If you want to run it as root, add the -r flag."
  86.            exit 1
  87.         fi
  88. fi
  89.  
  90. if [ "$CHANNEL" == "soft" ]; then
  91.         NAME="PocketMine-Soft"
  92. fi
  93.  
  94. ENABLE_GPG="no"
  95. PUBLICKEY_URL="http://cdn.pocketmine.net/pocketmine.asc"
  96. PUBLICKEY_FINGERPRINT="20D377AFC3F7535B3261AA4DCF48E7E52280B75B"
  97. PUBLICKEY_LONGID="${PUBLICKEY_FINGERPRINT: -16}"
  98. GPG_KEYSERVER="pgp.mit.edu"
  99.  
  100. function check_signature {
  101.         echo "[*] Checking signature of $1"
  102. #       "$GPG_BIN" --keyserver "$GPG_KEYSERVER" --keyserver-options auto-key-retrieve=1 --trusted-key $PUBLICKEY_LONGID --verify "$1.sig" "$1"
  103. #       if [ $? -eq 0 ]; then
  104. #               echo "[+] Signature valid and checked!"
  105. #       else
  106. #               "$GPG_BIN" --refresh-keys > /dev/null 2>&1
  107. #               echo "[!] Invalid signature! Please check for file corruption or a wrongly imported public key (signed by $PUBLICKEY_FINGERPRINT)"
  108. #               exit 1
  109. #       fi     
  110.         echo "[*] Check skipped"
  111. }
  112.  
  113. VERSION_DATA=$(download_file "http://www.pocketmine.net/api/?channel=$CHANNEL")
  114.  
  115. VERSION=$(echo "$VERSION_DATA" | grep '"version"' | cut -d ':' -f2- | tr -d ' ",')
  116. BUILD=$(echo "$VERSION_DATA" | grep build | cut -d ':' -f2- | tr -d ' ",')
  117. API_VERSION=$(echo "$VERSION_DATA" | grep api_version | cut -d ':' -f2- | tr -d ' ",')
  118. VERSION_DATE=$(echo "$VERSION_DATA" | grep '"date"' | cut -d ':' -f2- | tr -d ' ",')
  119. VERSION_DOWNLOAD=$(echo "$VERSION_DATA" | grep '"download_url"' | cut -d ':' -f2- | tr -d ' ",')
  120.  
  121. if [ "$(uname -s)" == "Darwin" ]; then
  122.         BASE_VERSION=$(echo "$VERSION" | sed -E 's/([A-Za-z0-9_\.]*).*/\1/')
  123.         VERSION_DATE_STRING=$(date -j -f "%s" $VERSION_DATE)
  124. else
  125.         BASE_VERSION=$(echo "$VERSION" | sed -r 's/([A-Za-z0-9_\.]*).*/\1/')
  126.         VERSION_DATE_STRING=$(date --date="@$VERSION_DATE")
  127. fi
  128.  
  129. GPG_SIGNATURE=$(echo "$VERSION_DATA" | grep '"signature_url"' | cut -d ':' -f2- | tr -d ' ",')
  130.  
  131. if [ "$GPG_SIGNATURE" != "" ]; then
  132.         ENABLE_GPG="yes"
  133. fi
  134.  
  135. if [ "$VERSION" == "" ]; then
  136.         echo "[!] Couldn't get the latest $NAME version"
  137.         exit 1
  138. fi
  139.  
  140. GPG_BIN=""
  141.  
  142. if [ "$ENABLE_GPG" == "yes" ]; then
  143.         type gpg > /dev/null 2>&1
  144.         if [ $? -eq 0 ]; then
  145.                 GPG_BIN="gpg"
  146.         else
  147.                 type gpg2 > /dev/null 2>&1
  148.                 if [ $? -eq 0 ]; then
  149.                         GPG_BIN="gpg2"
  150.                 fi
  151.         fi
  152.        
  153.         if [ "$GPG_BIN" != "" ]; then
  154.                 gpg --fingerprint $PUBLICKEY_FINGERPRINT > /dev/null 2>&1
  155.                 if [ $? -ne 0 ]; then
  156.                         download_file $PUBLICKEY_URL | gpg --trusted-key $PUBLICKEY_LONGID --import
  157.                         gpg --fingerprint $PUBLICKEY_FINGERPRINT > /dev/null 2>&1
  158.                         if [ $? -ne 0 ]; then
  159.                                 gpg --trusted-key $PUBLICKEY_LONGID --keyserver "$GPG_KEYSERVER" --recv-key $PUBLICKEY_FINGERPRINT
  160.                         fi
  161.                 fi
  162.         else
  163.                 ENABLE_GPG="no"
  164.         fi
  165. fi
  166.  
  167. echo "[*] Found $NAME $BASE_VERSION (build $BUILD) using API $API_VERSION"
  168. echo "[*] This $CHANNEL build was released on $VERSION_DATE_STRING"
  169.  
  170. if [ "$ENABLE_GPG" == "yes" ]; then
  171.         echo "[+] The build was signed, will check signature"
  172. elif [ "$GPG_SIGNATURE" == "" ]; then
  173.         if [[ "$CHANNEL" == "beta" ]] || [[ "$CHANNEL" == "stable" ]]; then
  174.                 echo "[-] This channel should have a signature, none found"
  175.         fi
  176. fi
  177.  
  178. echo "[*] Installing/updating $NAME on directory $INSTALL_DIRECTORY"
  179. mkdir -m 0777 "$INSTALL_DIRECTORY" 2> /dev/null
  180. cd "$INSTALL_DIRECTORY"
  181. echo "[1/3] Cleaning..."
  182. rm -f "$NAME.phar"
  183. rm -f README.md
  184. rm -f CONTRIBUTING.md
  185. rm -f LICENSE
  186. rm -f start.sh
  187. rm -f start.bat
  188.  
  189. #Old installations
  190. rm -f PocketMine-MP.php
  191. rm -r -f src/
  192.  
  193. echo -n "[2/3] Downloading $NAME $VERSION phar..."
  194. set +e
  195. download_file "$VERSION_DOWNLOAD" > "$NAME.phar"
  196. if ! [ -s "$NAME.phar" ] || [ "$(head -n 1 $NAME.phar)" == '<!DOCTYPE html>' ]; then
  197.         rm "$NAME.phar" 2> /dev/null
  198.         echo " failed!"
  199.         echo "[!] Couldn't download $NAME automatically from $VERSION_DOWNLOAD"
  200.         exit 1
  201. else
  202.         if [ "$CHANNEL" == "soft" ]; then
  203.                 download_file "https://raw.githubusercontent.com/PocketMine/PocketMine-Soft/master/resources/start.sh" > start.sh
  204.         else
  205.                 download_file "https://raw.githubusercontent.com/PocketMine/PocketMine-MP/master/start.sh" > start.sh
  206.         fi
  207.         download_file "https://raw.githubusercontent.com/PocketMine/PocketMine-MP/master/LICENSE" > LICENSE
  208.         download_file "https://raw.githubusercontent.com/PocketMine/PocketMine-MP/master/README.md" > README.md
  209.         download_file "https://raw.githubusercontent.com/PocketMine/PocketMine-MP/master/CONTRIBUTING.md" > CONTRIBUTING.md
  210.         download_file "https://raw.githubusercontent.com/PocketMine/php-build-scripts/master/compile.sh" > compile.sh
  211. fi
  212.  
  213. chmod +x compile.sh
  214. chmod +x start.sh
  215.  
  216. echo " done!"
  217.  
  218. if [ "$ENABLE_GPG" == "yes" ]; then
  219. #       download_file "$GPG_SIGNATURE" > "$NAME.phar.sig"
  220.         check_signature "$NAME.phar"
  221. fi
  222.  
  223. if [ "$update" == "on" ]; then
  224.         echo "[3/3] Skipping PHP recompilation due to user request"
  225. else
  226.         echo -n "[3/3] Obtaining PHP:"
  227.         if [ "$(uname -s)" == "Darwin" ]; then
  228.                 SECONDS_10=$(date -v+10S +%s)
  229.         else
  230.                 SECONDS_10=$(date --date="10 seconds" -u +%s)
  231.         fi
  232.         EXTRA_URL="?r=&ts=$SECONDS_10"
  233.         echo " detecting if build is available..."
  234.         if [ "$forcecompile" == "off" ] && [ "$(uname -s)" == "Darwin" ]; then
  235.                 set +e
  236.                 UNAME_M=$(uname -m)
  237.                 IS_IOS=$(expr match $UNAME_M 'iP[a-zA-Z0-9,]*' 2> /dev/null)
  238.                 set -e
  239.                 if [[ "$IS_IOS" -gt 0 ]]; then
  240.                         rm -r -f bin/ >> /dev/null 2>&1
  241.                         echo -n "[3/3] iOS PHP build available, downloading $IOS_BUILD.tar.gz..."
  242.                         download_file "https://downloads.sourceforge.net/project/pocketmine/builds/$IOS_BUILD.tar.gz$EXTRA_URL" | tar -zx > /dev/null 2>&1
  243.                         chmod +x ./bin/php5/bin/*
  244.                         echo -n " checking..."
  245.                         if [ "$(./bin/php5/bin/php -r 'echo 1;' 2>/dev/null)" == "1" ]; then
  246.                                 echo -n " regenerating php.ini..."
  247.                                 TIMEZONE=$(date +%Z)
  248.                                 echo "" > "./bin/php5/bin/php.ini"
  249.                                 #UOPZ_PATH="$(find $(pwd) -name uopz.so)"
  250.                                 #echo "zend_extension=\"$UOPZ_PATH\"" >> "./bin/php5/bin/php.ini"
  251.                                 echo "date.timezone=$TIMEZONE" >> "./bin/php5/bin/php.ini"
  252.                                 echo "short_open_tag=0" >> "./bin/php5/bin/php.ini"
  253.                                 echo "asp_tags=0" >> "./bin/php5/bin/php.ini"
  254.                                 echo "phar.readonly=0" >> "./bin/php5/bin/php.ini"
  255.                                 echo "phar.require_hash=1" >> "./bin/php5/bin/php.ini"
  256.                                 echo " done"
  257.                                 alldone=yes
  258.                         else
  259.                                 echo " invalid build detected"
  260.                         fi
  261.                 else
  262.                         rm -r -f bin/ >> /dev/null 2>&1
  263.                         if [ `getconf LONG_BIT` == "64" ]; then
  264.                                 echo -n "[3/3] MacOS 64-bit PHP build available, downloading $MAC_64_BUILD.tar.gz..."
  265.                                 MAC_BUILD="$MAC_64_BUILD"
  266.                         else
  267.                                 echo -n "[3/3] MacOS 32-bit PHP build available, downloading $MAC_32_BUILD.tar.gz..."
  268.                                 MAC_BUILD="$MAC_32_BUILD"
  269.                         fi
  270.                         download_file "https://downloads.sourceforge.net/project/pocketmine/builds/$MAC_BUILD.tar.gz$EXTRA_URL" | tar -zx > /dev/null 2>&1
  271.                         chmod +x ./bin/php5/bin/*
  272.                         echo -n " checking..."
  273.                         if [ "$(./bin/php5/bin/php -r 'echo 1;' 2>/dev/null)" == "1" ]; then
  274.                                 echo -n " regenerating php.ini..."
  275.                                 TIMEZONE=$(date +%Z)
  276.                                 #OPCACHE_PATH="$(find $(pwd) -name opcache.so)"
  277.                                 XDEBUG_PATH="$(find $(pwd) -name xdebug.so)"
  278.                                 echo "" > "./bin/php5/bin/php.ini"
  279.                                 #UOPZ_PATH="$(find $(pwd) -name uopz.so)"
  280.                                 #echo "zend_extension=\"$UOPZ_PATH\"" >> "./bin/php5/bin/php.ini"
  281.                                 #echo "zend_extension=\"$OPCACHE_PATH\"" >> "./bin/php5/bin/php.ini"
  282.                                 if [ "$XDEBUG" == "on" ]; then
  283.                                         echo "zend_extension=\"$XDEBUG_PATH\"" >> "./bin/php5/bin/php.ini"
  284.                                 fi
  285.                                 echo "opcache.enable=1" >> "./bin/php5/bin/php.ini"
  286.                                 echo "opcache.enable_cli=1" >> "./bin/php5/bin/php.ini"
  287.                                 echo "opcache.save_comments=1" >> "./bin/php5/bin/php.ini"
  288.                                 echo "opcache.load_comments=1" >> "./bin/php5/bin/php.ini"
  289.                                 echo "opcache.fast_shutdown=0" >> "./bin/php5/bin/php.ini"
  290.                                 echo "opcache.max_accelerated_files=4096" >> "./bin/php5/bin/php.ini"
  291.                                 echo "opcache.interned_strings_buffer=8" >> "./bin/php5/bin/php.ini"
  292.                                 echo "opcache.memory_consumption=128" >> "./bin/php5/bin/php.ini"
  293.                                 echo "opcache.optimization_level=0xffffffff" >> "./bin/php5/bin/php.ini"
  294.                                 echo "date.timezone=$TIMEZONE" >> "./bin/php5/bin/php.ini"
  295.                                 echo "short_open_tag=0" >> "./bin/php5/bin/php.ini"
  296.                                 echo "asp_tags=0" >> "./bin/php5/bin/php.ini"
  297.                                 echo "phar.readonly=0" >> "./bin/php5/bin/php.ini"
  298.                                 echo "phar.require_hash=1" >> "./bin/php5/bin/php.ini"
  299.                                 echo " done"
  300.                                 alldone=yes
  301.                         else
  302.                                 echo " invalid build detected"
  303.                         fi
  304.                 fi
  305.         else
  306.                 grep -q BCM2708 /proc/cpuinfo > /dev/null 2>&1
  307.                 IS_RPI=$?
  308.                 grep -q sun7i /proc/cpuinfo > /dev/null 2>&1
  309.                 IS_BPI=$?
  310.                 grep -q ODROID /proc/cpuinfo > /dev/null 2>&1
  311.                 IS_ODROID=$?
  312.                 if ([ "$IS_RPI" -eq 0 ] || [ "$IS_BPI" -eq 0 ]) && [ "$forcecompile" == "off" ]; then
  313.                         rm -r -f bin/ >> /dev/null 2>&1
  314.                         echo -n "[3/3] Raspberry Pi PHP build available, downloading $RPI_BUILD.tar.gz..."
  315.                         download_file "https://downloads.sourceforge.net/project/pocketmine/builds/$RPI_BUILD.tar.gz$EXTRA_URL" | tar -zx > /dev/null 2>&1
  316.                         chmod +x ./bin/php5/bin/*
  317.                         echo -n " checking..."
  318.                         if [ "$(./bin/php5/bin/php -r 'echo 1;' 2>/dev/null)" == "1" ]; then
  319.                                 echo -n " regenerating php.ini..."
  320.                                 TIMEZONE=$(date +%Z)
  321.                                 #OPCACHE_PATH="$(find $(pwd) -name opcache.so)"
  322.                                 if [ "$XDEBUG" == "on" ]; then
  323.                                         echo "zend_extension=\"$XDEBUG_PATH\"" >> "./bin/php5/bin/php.ini"
  324.                                 fi
  325.                                 echo "" > "./bin/php5/bin/php.ini"
  326.                                 #UOPZ_PATH="$(find $(pwd) -name uopz.so)"
  327.                                 #echo "zend_extension=\"$UOPZ_PATH\"" >> "./bin/php5/bin/php.ini"
  328.                                 #echo "zend_extension=\"$OPCACHE_PATH\"" >> "./bin/php5/bin/php.ini"
  329.                                 if [ "$XDEBUG" == "on" ]; then
  330.                                         echo "zend_extension=\"$XDEBUG_PATH\"" >> "./bin/php5/bin/php.ini"
  331.                                 fi
  332.                                 echo "opcache.enable=1" >> "./bin/php5/bin/php.ini"
  333.                                 echo "opcache.enable_cli=1" >> "./bin/php5/bin/php.ini"
  334.                                 echo "opcache.save_comments=1" >> "./bin/php5/bin/php.ini"
  335.                                 echo "opcache.load_comments=1" >> "./bin/php5/bin/php.ini"
  336.                                 echo "opcache.fast_shutdown=1" >> "./bin/php5/bin/php.ini"
  337.                                 echo "opcache.max_accelerated_files=4096" >> "./bin/php5/bin/php.ini"
  338.                                 echo "opcache.interned_strings_buffer=8" >> "./bin/php5/bin/php.ini"
  339.                                 echo "opcache.memory_consumption=128" >> "./bin/php5/bin/php.ini"
  340.                                 echo "opcache.optimization_level=0xffffffff" >> "./bin/php5/bin/php.ini"
  341.                                 echo "date.timezone=$TIMEZONE" >> "./bin/php5/bin/php.ini"
  342.                                 echo "short_open_tag=0" >> "./bin/php5/bin/php.ini"
  343.                                 echo "asp_tags=0" >> "./bin/php5/bin/php.ini"
  344.                                 echo "phar.readonly=0" >> "./bin/php5/bin/php.ini"
  345.                                 echo "phar.require_hash=1" >> "./bin/php5/bin/php.ini"
  346.                                 echo " done"
  347.                                 alldone=yes
  348.                         else
  349.                                 echo " invalid build detected"
  350.                         fi
  351.                 elif [ "$IS_ODROID" -eq 0 ] && [ "$forcecompile" == "off" ]; then
  352.                         rm -r -f bin/ >> /dev/null 2>&1
  353.                         echo -n "[3/3] ODROID PHP build available, downloading $ODROID_BUILD.tar.gz..."
  354.                         download_file "https://downloads.sourceforge.net/project/pocketmine/builds/$ODROID_BUILD.tar.gz$EXTRA_URL" | tar -zx > /dev/null 2>&1
  355.                         chmod +x ./bin/php5/bin/*
  356.                         echo -n " checking..."
  357.                         if [ "$(./bin/php5/bin/php -r 'echo 1;' 2>/dev/null)" == "1" ]; then
  358.                                 echo -n " regenerating php.ini..."
  359.                                 #OPCACHE_PATH="$(find $(pwd) -name opcache.so)"
  360.                                 XDEBUG_PATH="$(find $(pwd) -name xdebug.so)"
  361.                                 echo "" > "./bin/php5/bin/php.ini"
  362.                                 #UOPZ_PATH="$(find $(pwd) -name uopz.so)"
  363.                                 #echo "zend_extension=\"$UOPZ_PATH\"" >> "./bin/php5/bin/php.ini"
  364.                                 #echo "zend_extension=\"$OPCACHE_PATH\"" >> "./bin/php5/bin/php.ini"
  365.                                 if [ "$XDEBUG" == "on" ]; then
  366.                                         echo "zend_extension=\"$XDEBUG_PATH\"" >> "./bin/php5/bin/php.ini"
  367.                                 fi
  368.                                 echo "opcache.enable=1" >> "./bin/php5/bin/php.ini"
  369.                                 echo "opcache.enable_cli=1" >> "./bin/php5/bin/php.ini"
  370.                                 echo "opcache.save_comments=1" >> "./bin/php5/bin/php.ini"
  371.                                 echo "opcache.load_comments=1" >> "./bin/php5/bin/php.ini"
  372.                                 echo "opcache.fast_shutdown=1" >> "./bin/php5/bin/php.ini"
  373.                                 echo "opcache.max_accelerated_files=4096" >> "./bin/php5/bin/php.ini"
  374.                                 echo "opcache.interned_strings_buffer=8" >> "./bin/php5/bin/php.ini"
  375.                                 echo "opcache.memory_consumption=128" >> "./bin/php5/bin/php.ini"
  376.                                 echo "opcache.optimization_level=0xffffffff" >> "./bin/php5/bin/php.ini"
  377.                                 echo "date.timezone=$TIMEZONE" >> "./bin/php5/bin/php.ini"
  378.                                 echo "short_open_tag=0" >> "./bin/php5/bin/php.ini"
  379.                                 echo "asp_tags=0" >> "./bin/php5/bin/php.ini"
  380.                                 echo "phar.readonly=0" >> "./bin/php5/bin/php.ini"
  381.                                 echo "phar.require_hash=1" >> "./bin/php5/bin/php.ini"
  382.                                 echo " done"
  383.                                 alldone=yes
  384.                         else
  385.                                 echo " invalid build detected"
  386.                         fi
  387.                 elif [ "$forcecompile" == "off" ] && [ "$(uname -s)" == "Linux" ]; then
  388.                         rm -r -f bin/ >> /dev/null 2>&1
  389.                        
  390.                         if [[ "$(cat /etc/redhat-release 2>/dev/null)" == *CentOS* ]]; then
  391.                                 if [ `getconf LONG_BIT` = "64" ]; then
  392.                                         echo -n "[3/3] CentOS 64-bit PHP build available, downloading $CENTOS_64_BUILD.tar.gz..."
  393.                                         LINUX_BUILD="$CENTOS_64_BUILD"
  394.                                 else
  395.                                         echo -n "[3/3] CentOS 32-bit PHP build available, downloading $CENTOS_32_BUILD.tar.gz..."
  396.                                         LINUX_BUILD="$CENTOS_32_BUILD"
  397.                                 fi
  398.                         else
  399.                                 if [ `getconf LONG_BIT` = "64" ]; then
  400.                                         echo -n "[3/3] Linux 64-bit PHP build available, downloading $LINUX_64_BUILD.tar.gz..."
  401.                                         LINUX_BUILD="$LINUX_64_BUILD"
  402.                                 else
  403.                                         echo -n "[3/3] Linux 32-bit PHP build available, downloading $LINUX_32_BUILD.tar.gz..."
  404.                                         LINUX_BUILD="$LINUX_32_BUILD"
  405.                                 fi
  406.                         fi
  407.                        
  408.                         download_file "https://downloads.sourceforge.net/project/pocketmine/builds/$LINUX_BUILD.tar.gz$EXTRA_URL" | tar -zx > /dev/null 2>&1
  409.                         chmod +x ./bin/php5/bin/*
  410.                         echo -n " checking..."
  411.                         if [ "$(./bin/php5/bin/php -r 'echo 1;' 2>/dev/null)" == "1" ]; then
  412.                                 echo -n " regenerating php.ini..."
  413.                                 #OPCACHE_PATH="$(find $(pwd) -name opcache.so)"
  414.                                 XDEBUG_PATH="$(find $(pwd) -name xdebug.so)"
  415.                                 echo "" > "./bin/php5/bin/php.ini"
  416.                                 #UOPZ_PATH="$(find $(pwd) -name uopz.so)"
  417.                                 #echo "zend_extension=\"$UOPZ_PATH\"" >> "./bin/php5/bin/php.ini"
  418.                                 #echo "zend_extension=\"$OPCACHE_PATH\"" >> "./bin/php5/bin/php.ini"
  419.                                 if [ "$XDEBUG" == "on" ]; then
  420.                                         echo "zend_extension=\"$XDEBUG_PATH\"" >> "./bin/php5/bin/php.ini"
  421.                                 fi
  422.                                 echo "opcache.enable=1" >> "./bin/php5/bin/php.ini"
  423.                                 echo "opcache.enable_cli=1" >> "./bin/php5/bin/php.ini"
  424.                                 echo "opcache.save_comments=1" >> "./bin/php5/bin/php.ini"
  425.                                 echo "opcache.fast_shutdown=1" >> "./bin/php5/bin/php.ini"
  426.                                 echo "opcache.max_accelerated_files=4096" >> "./bin/php5/bin/php.ini"
  427.                                 echo "opcache.interned_strings_buffer=8" >> "./bin/php5/bin/php.ini"
  428.                                 echo "opcache.memory_consumption=128" >> "./bin/php5/bin/php.ini"
  429.                                 echo "opcache.optimization_level=0xffffffff" >> "./bin/php5/bin/php.ini"
  430.                                 echo "date.timezone=$TIMEZONE" >> "./bin/php5/bin/php.ini"
  431.                                 echo "short_open_tag=0" >> "./bin/php5/bin/php.ini"
  432.                                 echo "asp_tags=0" >> "./bin/php5/bin/php.ini"
  433.                                 echo "phar.readonly=0" >> "./bin/php5/bin/php.ini"
  434.                                 echo "phar.require_hash=1" >> "./bin/php5/bin/php.ini"
  435.                                 echo " done"
  436.                                 alldone=yes
  437.                         else
  438.                                 echo " invalid build detected, please upgrade your OS"
  439.                         fi
  440.                 fi
  441.                 if [ "$alldone" == "no" ]; then
  442.                         set -e
  443.                         echo "[3/3] no build found, compiling PHP automatically"
  444.                         exec "./compile.sh"
  445.                 fi
  446.         fi
  447. fi
  448.  
  449. rm compile.sh
  450.  
  451. echo "[*] Everything done! Run ./start.sh to start $NAME"
  452. exit 0

Reply to "PMInstall - nocheck"

Here you can reply to the paste above

captcha